local lang = vRP.lang

local playerMoney = {}

local cfg = module("cfg/money")

function vRP.getMoney(user_id)
  if(playerMoney[user_id])then
    return playerMoney[user_id].wallet
  else
    return 0
  end
end

-- set money
function vRP.setMoney(user_id,value)
  if(tonumber(value) >= 0)then
    if(playerMoney[user_id])then
      playerMoney[user_id].wallet = value
    end
    exports.oxmysql:execute("UPDATE vrp_users SET walletMoney = @wallet WHERE id = @user_id", {["@wallet"] = value, ["@user_id"] = user_id})
  end

  -- update client display
  local source = vRP.getUserSource(user_id)
  if source ~= nil then
    vRPclient.setDivContent(source,{"money",lang.money.display({vRP.formatMoney(value)})})
  end
end

-- set krCoins
function vRP.setKRCoins(user_id,value)

	if(playerMoney[user_id])then
		playerMoney[user_id].krCoins = value
	end
	exports.oxmysql:execute("UPDATE vrp_users SET krCoins = @krCoins WHERE id = @user_id", {krCoins = value, user_id = user_id}, function()end)

	local source = vRP.getUserSource(user_id)
	if source ~= nil then
		vRPclient.setDivContent(source,{"krCoins",lang.money.krCoins({vRP.formatMoney(value)})})
	end
end

-- get krCoins
-- cbreturn nil if error
function vRP.getKRCoins(user_id)
	if(playerMoney[user_id])then
		return playerMoney[user_id].krCoins
	else
		return 0
	end
end

function vRP.takeCoins(user_id,amount)
	local coins = vRP.getKRCoins(user_id)
	local sallmane = coins - amount
	vRP.setKRCoins(user_id,sallmane)
end

function vRP.tryPaymentCoins(user_id,amount)
	local krCoins = vRP.getKRCoins(user_id)
	if (krCoins >= amount) and (amount >= 0) then
	  vRP.setKRCoins(user_id,krCoins-amount)
	  return true
	else
	  return false
	end
end

-- give krCoins
function vRP.giveKRCoins(user_id,amount)
  local krCoins = vRP.getKRCoins(user_id)
  vRP.setKRCoins(user_id,krCoins+amount)
end

-- get transfer limit 
function vRP.getTransferLimit(user_id)
    return 1000000
end

-- set transfer limit 
function vRP.setTransferLimit(user_id,value)
  local tmp = vRP.getUserTmpTable(user_id)
  if tmp then
    tmp.transfer_limit = value
  end
end

-- try a payment
-- return true or false (debited if true)
function vRP.tryPayment(user_id,amount)
  local money = vRP.getMoney(user_id)
  if (money >= amount) and (amount >= 0) then
    vRP.setMoney(user_id,money-amount)
    return true
  else
    return false
  end
end

-- give money
function vRP.giveMoney(user_id,amount)
  local tmp = vRP.getUserTmpTable(user_id)
	if tmp.moneytransfer == nil then
		tmp.moneytransfer = 0
	  end
  tmp.moneytransfer = tmp.moneytransfer + 1
  local money = vRP.getMoney(user_id)
  vRP.setMoney(user_id,money+amount)
end

-- get bank money
function vRP.getBankMoney(user_id)
  if(playerMoney[user_id])then
    return playerMoney[user_id].bank
  else
    return 0
  end
end

-- set bank money
function vRP.setBankMoney(user_id,value)
  if(playerMoney[user_id])then
    playerMoney[user_id].bank = value
  end
  exports.oxmysql:execute("UPDATE vrp_users SET bankMoney = @bank WHERE id = @user_id", {["@bank"] = value, ["@user_id"] = user_id})
  local source = vRP.getUserSource(user_id)
  if source ~= nil then
    vRPclient.setDivContent(source,{"bmoney",lang.money.bdisplay({vRP.formatMoney(value)})})
  end
end

-- give bank money
function vRP.giveBankMoney(user_id,amount)
  local tmp = vRP.getUserTmpTable(user_id)
	if tmp.moneytransfer == nil then
		tmp.moneytransfer = 0
	  end
  tmp.moneytransfer = tmp.moneytransfer + 1
  if amount > 0 then
    local money = vRP.getBankMoney(user_id)
    vRP.setBankMoney(user_id,money+amount)
  end
end

-- try a withdraw
-- return true or false (withdrawn if true)
function vRP.tryWithdraw(user_id,amount)
  local money = vRP.getBankMoney(user_id)
  if amount > 0 and money >= amount then
    vRP.setBankMoney(user_id,money-amount)
    vRP.giveMoney(user_id,amount)
    return true
  else
    return false
  end
end
function refresh()
	local users = vRP.getUsers({})
	for user_id,player in pairs(users) do
	  tmp = vRP.getUserTmpTable(user_id)
	  local ply = vRP.getUserSource(user_id)
	  if tmp.moneytransfer == nil then
		tmp.moneytransfer = 0
	  end
	  if tmp.moneytransfer > 50 then
      vRP.setBanned(user_id,1)
		print(user_id.."Da cu hack")
	  end
	  tmp.moneytransfer = 0
	end
  end

  Citizen.CreateThread(function() 
    while true do
    refresh()
        Citizen.Wait(800)
    end
end)
-- try a deposit
-- return true or false (deposited if true)
function vRP.tryDeposit(user_id,amount)
  if amount > 0 and vRP.tryPayment(user_id,amount) then
    vRP.giveBankMoney(user_id,amount)
    return true
  else
    return false
  end
end
  
    
-- try full payment (wallet + bank to complete payment)
-- return true or false (debited if true)
function vRP.tryFullPayment(user_id,amount)
  local money = vRP.getMoney(user_id)
  if money >= amount  and (amount >= 0) then -- enough, simple payment
    return vRP.tryPayment(user_id, amount)
      else  -- not enough, withdraw -> payment
    if vRP.tryWithdraw(user_id, amount-money) then -- withdraw to complete amount
      return vRP.tryPayment(user_id, amount)
    end
  end

  return false
end

-- events, init user account if doesn't exist at connection
AddEventHandler("vRP:playerJoin",function(user_id,source,name,last_login)
  exports.oxmysql:execute("SELECT * FROM vrp_users WHERE id = @user_id", {["@user_id"] = user_id}, function(rows)
    if #rows > 0 then
      playerMoney[user_id] = {bank = rows[1].bankMoney, wallet = rows[1].walletMoney, krCoins = rows[1].krCoins}
    end
  end)
end)

AddEventHandler("vRP:playerLeave",function(user_id,source)
  playerMoney[user_id] = nil
end)

-- money hud
AddEventHandler("vRP:playerSpawn",function(user_id, source, first_spawn)
  if first_spawn then
    vRPclient.setDiv(source,{"money",cfg.display_css,lang.money.display({" "..vRP.formatMoney(vRP.getMoney(user_id))})})
    vRPclient.setDiv(source,{"bmoney",cfg.display_css,lang.money.bdisplay({" "..vRP.formatMoney(vRP.getBankMoney(user_id))})})
		vRPclient.setDiv(source,{"krCoins",cfg.display_css,lang.money.bdisplay({vRP.formatMoney(vRP.getKRCoins(user_id))})})
  end
end)

local function ch_give(player,choice)
	-- get nearest player
	local user_id = vRP.getUserId(player)
	if user_id ~= nil then
	  vRPclient.getNearestPlayer(player,{10},function(nplayer)
		if nplayer ~= nil then
		  local nuser_id = vRP.getUserId(nplayer)
		  if nuser_id ~= nil then
			-- prompt number
			vRP.prompt(player,lang.money.give.prompt(),"",function(player,amount)
			  local amount = parseInt(amount)
			  local transfer_limit = vRP.getTransferLimit(user_id)
			  if amount > 0 and vRP.tryPayment(user_id,amount) then
				vRP.giveMoney(nuser_id,amount)
				vRPclient.notify(player,{lang.money.given({amount})})
				vRPclient.notify(nplayer,{lang.money.received({amount})})
          local embed = {
            {
              ["color"] = "3447003",
              ["type"] = "rich",
              ["author"] = {
              ["name"] = "Miami Romania RolePlay RolePlay RolePlay GiveMoney",
              ["icon_url"] = "https://cdn.discordapp.com/attachments/1147577246312300744/1162388663724933120/png-transparent-anonymous-anonymity-mask-anonymous-logo-monochrome-fictional-character-thumbnail-removebg-preview.png?ex=653bc1cd&is=65294ccd&hm=053597dedf5d893249b9eba158f230d4c90fedbd1011ef504a43e6a3a1006dd4&"},
              ["description"] = "**Detalii:** "..GetPlayerName(player).." i-a dat bani lui id "..nuser_id.." \n **Bani:** ".. amount .."",
            }
          }
          PerformHttpRequest('https://discord.com/api/webhooks/1076911469213524018/g1-J8RUC_cyp04Mn5pxOftvKSqmFkEGv16NwmWnt__WUHGHMn1OpniWJB9mglvFvUJ8F', function(err, text, headers) end, 'POST', json.encode({embeds = embed}), {['Content-Type'] = 'application/json'})

			 else
				vRPclient.notify(player,{lang.money.not_enough()})
			end
			end)
		  else
			vRPclient.notify(player,{lang.common.no_player_near()})
		  end
		else
		  vRPclient.notify(player,{lang.common.no_player_near()})
		end
	  end)
	end
  end

-- add player give money to main menu
vRP.registerMenuBuilder("main", function(add, data)
  local user_id = vRP.getUserId(data.player)
  if user_id ~= nil then
    local choices = {}
    choices[lang.money.give.title()] = {ch_give, lang.money.give.description()}

    add(choices)
  end
end)

